<?php
/*
 *   Copyright (C) 2011 by Rick Schnicker KD0OSS
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// include lib
include_once("linb.php");
include_once("config.php");
include_once("remoteC.php");

if ($logPrefix == "") $logPrefix = "GMSK";

function readRepeaterLog($ldir, $pos)
{
    global $logPrefix;
    
    $tx = "Off";
    $ber = "0.0%";
    $ack = "";
    $flags = "00 00 00";
    $state = "Listening";
    $x = 0;
    $found = 0;
    $size = -1;
    $your = "";
    $my = "";
    $rpt1 = "";
    $rpt2 = "";
    
    $fp = @fopen($ldir."/".$logPrefix."Repeater-".date("Y-m-d").".log","r");
    if ($fp === false) return "1^na^";
    while (!feof($fp))
    {
        $lines[0] = fgets($fp);
        $size++;
        if ($size != $pos && $found == 0) continue;
        $found = 1;
        $fields = split(" ", $lines[$x]);
        if (count($fields) < 4) continue;
        if ($fields[3] == "Local") { $tx = "Off"; $state = "Listening"; }
        if ($fields[3] == "Transmitting")
        {
            $tx = "On";
            $state = "Network";
            $fields = split("My:", $lines[$x]);
            if (count($fields) > 1)
            {
                $my = trim(substr($fields[1],1,13));
                $fields = split("Your:", $lines[$x]);
                $your = trim(substr($fields[1],1,8));
                $fields = split("Rpt1:", $lines[$x]);
                $rpt1 = trim(substr($fields[1],1,8));
                $fields = split("Rpt2:", $lines[$x]);
                $rpt2 = trim(substr($fields[1],1,8));
                $fields = split("Flags:", $lines[$x]);
                $flags = trim(substr($fields[1],1,8));
            }
            continue;
        }
    
        if ($fields[3] == "Header")
        {
            $tx = "On";
            $state = "Valid";
            $fields = split("My:", $lines[$x]);
            if (count($fields) > 1)
            {
                $my = trim(substr($fields[1],1,13));
                $fields = split("Your:", $lines[$x]);
                $your = trim(substr($fields[1],1,8));
                $fields = split("Rpt1:", $lines[$x]);
                $rpt1 = trim(substr($fields[1],1,8));
                $fields = split("Rpt2:", $lines[$x]);
                $rpt2 = trim(substr($fields[1],1,8));
                $fields = split("Flags:", $lines[$x]);
                $flags = trim(substr($fields[1],1,8));
            }
            continue;
        }
        
        if ($fields[3] == "AMBE" || $fields[4] == "cycle")
        {
            $tx = "Off";
            $state = "Listening";
            if ($fields[3] == "AMBE")
            {
                $fields = split("BER:", $lines[$x]);
                $ber = trim(substr($fields[1],1,6));
            }
            continue;
        }
        
        if ($fields[3] == "Slow")
        {
            $fields = split("\"", $lines[$x]);
            if (count($fields) > 1)
                $ack = trim($fields[1]);
            continue;
        }
    
        if ($fields[3] == "Starting")
        {
            $ack = "Not Linked";
            $tx = "Off";
            $state = "Listening";
        }
    }
    fclose($fp);

    if ($size == $pos+1 && $logPrefix == "DStar")
    {
            $ack = "Not Linked";
            $tx = "Off";
            $state = "Listening";
    }
    return ($size-1)."^".$tx."^".$my."^".$your."^".$rpt1."^".$rpt2."^".$flags."^".$ber."^".$state."^".$ack;
}/** end readRepeaterLog **/


function getLinks($ldir)
{
    $refl = "";
    $output = "";
    $lines = @file($ldir."/Links.log", FILE_IGNORE_NEW_LINES);
    if (count($lines) == 0) return "none";
    for ($i=0;$i<count($lines);$i++)
    {
        $mod1 = "";
        $mod2 = "";
        $refl = "";
        if (strpos($lines[$i], "User:") === false)
            sscanf($lines[$i], "%*s %*s %*s %*s %*s %*s %s %*s %s %s %*s %s %s %*s %s", $type, $callsign, $mod1, $refl, $mod2, $dir);
        else
            sscanf($lines[$i], "%*s %*s %*s %*s %*s %*s %s %*s %s %*s %s", $type, $callsign, $dir);
        $callsign = trim($callsign." ".$mod1);
        $refl = trim($refl." ".$mod2);
        if ($output != "") $output .= "|";
        $output .= $type.",".$dir.",".$callsign.",".$refl;
    }
    return $output;
}/** end getLinks **/

    
function getGatewayConfig($cdir)
{
    global $clubname;
    
    $config = @file($cdir."/ircddbgateway", FILE_IGNORE_NEW_LINES);
    return $clubname."\n".implode("\n", $config);
}/** end getGatewayConfig **/


function getModLastHeard($ldir, $module)
{
    global $logPrefix;
    global $rptCall;
    
    $output = "";
    $temp = array();

    for ($i=2;$i>=0;$i--)
    {
        $fp = @fopen($ldir."/".$logPrefix."Repeater-".date("Y-m-d", mktime(0, 0, 0, date("m"), date("d")-$i, date("Y"))).".log", "r");
        if ($fp === false) continue;
        while (!feof($fp))
        {
            $line = fgets($fp);
            if (!strstr($line, "Transmitting") && !strstr($line, "Header decoded")) continue;
            sscanf($line, "%*s %s %s %*s %*s %*s %*s %s %s", $date, $time, $my, $suffix);
            $fields = explode("Rpt1: ", $line);
            sscanf($fields[1], "%s %s", $rpt1, $mod1);
            $fields = explode("Rpt2: ", $line);
            sscanf($fields[1], "%s %s", $rpt2, $mod2);
            $datetime = $date." ".$time;
            if ($mod1 == $module || $mod2 == $module || $rpt1 == "DIRECT")
            {
                if ($my == $rptCall) continue;
                $temp[trim($my." ".$suffix)] = $datetime;
            }
        }
        fclose($fp);
    }
    
    if (count($temp) > 0)
    {
        arsort($temp);
        while (count($temp) > 10) array_pop($temp);
        foreach ($temp as $key => $val)
        {
            if (strlen($output) > 0) $output = $output . "^";
            $output = $output . $key . "," . $val;
        }
    }
    
    return $output;
}/** end getModLastHeard **/


function getSnLastHeard($group)
{
    global $rptCall;
    global $gwlogdir;
    global $timeOffset;
         
    $output = "";
    $count = 0;
    $lines = @file($gwlogdir."/Headers.log", FILE_IGNORE_NEW_LINES);
    $lines = array_reverse($lines);
    if (count($lines) < 1) return "empty";
    for ($i=0;$i<count($lines);$i++)
    {
        $fields = explode(": ", $lines[$i]);
        $tmp = explode(" ", trim($fields[2]));
        if (strstr($fields[3], $group))
        {
            $tmp = explode("Your", $fields[2]);
            if (strstr($tmp[0], $rptCall)) continue;
            if (strstr($output, trim($tmp[0]))) continue;
            if ($output != "") $output = "^".$output;
            $time = strtotime($fields[0]." $timeOffset hours");
            $output = trim($tmp[0]).",".date("Y-m-d H:i:s", $time).$output;
            $count++;
            if ($count == 10) break;
        }
    }
    return $output;
}/** end getSnLastHeard **/


function getDExtraDPlusHosts($cdir)
{
    $lines = @file($cdir."/DExtra_Hosts.txt", FILE_IGNORE_NEW_LINES);
    $lines = @array_merge($lines, @file($cdir."/DPlus_Hosts.txt", FILE_IGNORE_NEW_LINES));
   $lines = @array_merge($lines, @file($cdir."/DCS_Hosts.txt", FILE_IGNORE_NEW_LINES));
if (count($lines) < 1) return "na\n";
    return implode("\n", $lines);
} /** end getDExtraDPlusHosts **/


function chgLinkStatus($mod, $refector, $password)
{
    global $rptCall;

    $module = sprintf("%-7s%s", $rptCall, $mod);
    if (strstr($refector, "None") != NULL) $refector = "";
    $ret = sendRemoteCommand($module, "link,".$refector, $password);
    return $ret;
} /** end chgLinkStatus **/


$outputData=new stdClass;
$ok=true;

try
{
    // get request data
    $inputData = linb_getRequestData();
    $ok=true;

    if (isset($inputData->gconf))
        $outputData->strGConfig = getGatewayConfig($gwdir);

    if (isset($inputData->links))
        $outputData->strLinks = getLinks($gwlogdir);

    if (isset($inputData->pass))
        $outputData->strLinkStat = chgLinkStatus($inputData->mod, $inputData->ref, $inputData->pass);

    if (isset($inputData->mlh))
    {
        $outputData->strStations = "na";
        if ($inputData->rptr == "1")
            $outputData->strStations = getModLastHeard($rpt1logdir, $inputData->mlh);
        if ($inputData->rptr == "2")
            $outputData->strStations = getModLastHeard($rpt2logdir, $inputData->mlh);
        if ($inputData->rptr == "3")
            $outputData->strStations = getModLastHeard($rpt3logdir, $inputData->mlh);
        if ($inputData->rptr == "4")
            $outputData->strStations = getModLastHeard($rpt4logdir, $inputData->mlh);
    }
    
    if (isset($inputData->glh))
    {
        $outputData->strStations = getSnLastHeard($inputData->glh);
    }
    
    if (isset($inputData->ghosts))
        $outputData->strHosts = getDExtraDPlusHosts($hostsdir);

    if (isset($inputData->pos))
    {
        if ($inputData->ldir == "Repeater 1")
        {
            $outputData->strStatus = readRepeaterLog($rpt1logdir, $inputData->pos);
        }
        if ($inputData->ldir == "Repeater 2")
        {
            $outputData->strStatus = readRepeaterLog($rpt2logdir, $inputData->pos);
        }
        if ($inputData->ldir == "Repeater 3")
        {
            $outputData->strStatus = readRepeaterLog($rpt3logdir, $inputData->pos);
        }
        if ($inputData->ldir == "Repeater 4")
        {
            $outputData->strStatus = readRepeaterLog($rpt4logdir, $inputData->pos);
        }
    }
            
    $outputData->inputData=$inputData;
}
catch (Exception $e)
{
    // fail
    $ok=false;
        
    // error info
    $outputData->code = $e->getCode();
    $outputData->message = $e->getMessage();
}

// echo result
linb_echoResponse($inputData, $outputData, $ok); 
?>
